(define (domain log)
  (:model (:dynamics :non-deterministic) (:feedback :null))
  (:types OBJ TRUCK LOCATION AIRPLANE CITY AIRPORT )
  (:predicates 	(at_tl TRUCK LOCATION)
		(at_ta TRUCK AIRPORT)
		(at_aa AIRPLANE AIRPORT)
		(at_ol OBJ LOCATION)
		(at_oa OBJ AIRPORT)
		(in_ot OBJ TRUCK)
		(in_oa OBJ AIRPLANE)
		(in_city_l LOCATION CITY)
		(in_city_a AIRPORT CITY)
		(in_city_t TRUCK CITY))

(:action LOAD_TRUCK_LOC
  :parameters
    ?obj - OBJ
    ?truck - TRUCK
    ?loc - LOCATION 
    ?city - CITY
  :precondition
   (:and 
	(at_tl ?truck ?loc) 
 	(in_city_t ?truck ?city)
	(in_city_l ?loc ?city)
  
   )
  :effect
   (:when (at_ol ?obj ?loc) 
         (:set (at_ol ?obj ?loc) false) 
	 (:set (in_ot ?obj ?truck) true)))

(:action LOAD_TRUCK_AP
  :parameters
   ?obj - OBJ
    ?truck - TRUCK
    ?loc - AIRPORT
    ?city - CITY
  :precondition
   (:and 
	(at_ta ?truck ?loc) 
 	(in_city_t ?truck ?city)
	(in_city_a ?loc ?city)
  
   )
  :effect
   (:when (at_oa ?obj ?loc) 
         (:set (at_oa ?obj ?loc) false) 
	  (:set (in_ot ?obj ?truck) true)))

(:action LOAD_AIRPLANE
  :parameters
   ?obj - OBJ ?airplane - AIRPLANE ?loc - AIRPORT 
  :precondition
   (at_aa ?airplane ?loc)
  :effect
   (:when (at_oa ?obj ?loc) 
         (:set (at_oa ?obj ?loc) false) 
         (:set (in_oa ?obj ?airplane) true)))

(:action UNLOAD_TRUCK_LOC
  :parameters
   ?obj - OBJ
    ?truck - TRUCK
    ?loc - LOCATION
    ?city - CITY
  :precondition
   (:and 
	(at_tl ?truck ?loc) 
	(in_city_t ?truck ?city)
	(in_city_l ?loc ?city)
     
   )
  :effect
   (:when (in_ot ?obj ?truck) 
	 (:set (in_ot ?obj ?truck) false) 
         (:set (at_ol ?obj ?loc) true)))

(:action UNLOAD_TRUCK_AP
  :parameters
   ?obj - OBJ
    ?truck - TRUCK
    ?loc - AIRPORT
    ?city - CITY
  :precondition
   (:and 
	(at_ta ?truck ?loc) 
	(in_city_t ?truck ?city)
	(in_city_a ?loc ?city)
        ;(not (at_ol ?obj ?loc))
   )
  :effect
   (:when (in_ot ?obj ?truck) 
	 (:set (in_ot ?obj ?truck) false) 
         (:set (at_oa ?obj ?loc) true)))

(:action UNLOAD_AIRPLANE
  :parameters
   ?obj - OBJ
    ?airplane - AIRPLANE
    ?loc - AIRPORT
  :precondition
   (at_aa ?airplane ?loc)	
  :effect
   (:when (in_oa ?obj ?airplane)   
	 (:set (in_oa ?obj ?airplane) false) 
         (:set (at_oa ?obj ?loc) true)))

(:action DRIVE_TRUCK_LOC_AP
  :parameters
   ?truck - TRUCK
    ?loc1 - LOCATION
    ?loc2 - AIRPORT
    ?city - CITY
  :precondition
   (:and (at_tl ?truck ?loc1)
        (in_city_l ?loc1 ?city)
        (in_city_a ?loc2 ?city)
	(in_city_t ?truck ?city)
	;(not (at_ta ?truck ?loc2))
   )
  :effect
   (:set (at_tl ?truck ?loc1) false) 
   (:set (at_ta ?truck ?loc2) true))

(:action DRIVE_TRUCK_AP_LOC
  :parameters
   ?truck - TRUCK
    ?loc1 - AIRPORT
    ?loc2 - LOCATION 
    ?city - CITY
    :precondition
   (:and (at_ta ?truck ?loc1)
        (in_city_a ?loc1 ?city)
        (in_city_l ?loc2 ?city)
	(in_city_t ?truck ?city)
	;(not (at_tl ?truck ?loc2))
   )
  :effect
   (:set (at_ta ?truck ?loc1) false) 
   (:set (at_tl ?truck ?loc2) true))

(:action FLY_AIRPLANE
  :parameters
   ?airplane - AIRPLANE
    ?loc1 - AIRPORT
    ?loc2 - AIRPORT
  :precondition
  	(at_aa ?airplane ?loc1)
	
  :effect
   (:set (at_aa ?airplane ?loc1) false)
   (:set (at_aa ?airplane ?loc2 ) true))
)
 



(define (problem p1)   
(:domain log)
  (:objects     package1 - OBJ
                pgh_truck - TRUCK
                bos_truck - TRUCK
                airplane1 - AIRPLANE
                bos_po - LOCATION
                pgh_po - LOCATION
                bos_airport - AIRPORT
                pgh_airport - AIRPORT
                pgh - CITY
                bos - CITY
        )
 (:init (:set (at_ol package1 pgh_po) :in {true false})
    	(:set (at_ol package1 bos_po) :in {true false})
	(:iff (at_ol package1 pgh_po) (:not (at_ol package1 bos_po)))
  	(:set (in_oa package1 airplane1) false)
        (:set (in_ot package1 bos_truck) false)
        (:set (in_ot package1 pgh_truck) false)
	(:set (at_oa package1 pgh_airport) false)	
	(:set (at_oa package1 bos_airport) false)
  	(:set (at_aa airplane1 pgh_airport) true)
	(:set (at_aa airplane1 bos_airport) false)
	(:set (at_tl bos_truck bos_po) true)
       (:set (at_ta bos_truck bos_airport) false)
	(:set (at_tl bos_truck pgh_po) false)
	(:set (at_ta bos_truck pgh_airport) false)
	(:set (at_tl pgh_truck pgh_po) true)
      (:set (at_ta pgh_truck bos_airport) false)
        (:set (at_tl pgh_truck bos_po) false)
        (:set (at_ta pgh_truck pgh_airport) false)
	(:set (in_city_l bos_po bos) true)
	(:set (in_city_l bos_po pgh) false)
	(:set (in_city_a bos_airport bos) true)
	(:set (in_city_a bos_airport pgh) false)
	(:set (in_city_l pgh_po pgh) true)
	(:set (in_city_l pgh_po bos) false)
	(:set (in_city_a pgh_airport pgh) true)
	(:set (in_city_a pgh_airport bos) false)
	(:set (in_city_t pgh_truck pgh) true)
	(:set (in_city_t pgh_truck bos) false)
	(:set (in_city_t bos_truck bos) true)
	(:set (in_city_t bos_truck pgh) false)
)

  (:goal (at_oa package1 bos_airport))
  )

 
(define (problem p2)   
(:domain log)
  (:objects     package1 - OBJ
	        package2 - OBJ
       		pgh_truck - TRUCK
                bos_truck - TRUCK
                airplane1 - AIRPLANE
                bos_po - LOCATION
                pgh_po - LOCATION
                bos_airport - AIRPORT
                pgh_airport - AIRPORT
                pgh - CITY
                bos - CITY
        )
 (:init (:set (at_ol package1 pgh_po) :in {true false})
    	(:set (at_ol package1 bos_po) :in {true false})
	(:set (at_ol package2 pgh_po) :in {true false})
    	(:set (at_ol package2 bos_po) :in {true false})
	(:iff (at_ol package1 pgh_po) (:not (at_ol package1 bos_po)))
    	(:iff (at_ol package2 pgh_po) (:not (at_ol package2 bos_po)))
	(:set (in_oa package1 airplane1) false)
        (:set (in_ot package1 bos_truck) false)
        (:set (in_ot package1 pgh_truck) false)
	(:set (in_oa package2 airplane1) false)
        (:set (in_ot package2 bos_truck) false)
        (:set (in_ot package2 pgh_truck) false)
	(:set (at_oa package1 pgh_airport) false)	
	(:set (at_oa package1 bos_airport) false)
	(:set (at_oa package2 pgh_airport) false)	
	(:set (at_oa package2 bos_airport) false)
	(:set (at_aa airplane1 pgh_airport) true)
	(:set (at_aa airplane1 bos_airport) false)
	(:set (at_tl bos_truck bos_po) true)
        (:set (at_ta bos_truck bos_airport) false)
	(:set (at_tl bos_truck pgh_po) false)
	(:set (at_ta bos_truck pgh_airport) false)
	(:set (at_tl pgh_truck pgh_po) true)
      (:set (at_ta pgh_truck bos_airport) false)
        (:set (at_tl pgh_truck bos_po) false)
        (:set (at_ta pgh_truck pgh_airport) false)
	(:set (in_city_l bos_po bos) true)
	(:set (in_city_l bos_po pgh) false)
	(:set (in_city_a bos_airport bos) true)
	(:set (in_city_a bos_airport pgh) false)
	(:set (in_city_l pgh_po pgh) true)
	(:set (in_city_l pgh_po bos) false)
	(:set (in_city_a pgh_airport pgh) true)
	(:set (in_city_a pgh_airport bos) false)
	(:set (in_city_t pgh_truck pgh) true)
	(:set (in_city_t pgh_truck bos) false)
	(:set (in_city_t bos_truck bos) true)
	(:set (in_city_t bos_truck pgh) false)
)

  (:goal (:and 
		(at_oa package1 bos_airport)
		(at_oa package2 bos_airport)

	  ))
)
(define (problem p3)   
(:domain log)
  (:objects     package1 - OBJ
	     
       		pgh_truck - TRUCK
                bos_truck - TRUCK
                 phx_truck - TRUCK
              airplane1 - AIRPLANE
                bos_po - LOCATION
                pgh_po - LOCATION
                  phx_po - LOCATION
              bos_airport - AIRPORT
                pgh_airport - AIRPORT
                 phx_airport - AIRPORT
               pgh - CITY
                bos - CITY
                 phx - CITY
       )
 (:init (:set (at_ol package1 pgh_po) :in {true false})
    	(:set (at_ol package1 bos_po) :in {true false})

	(:iff (at_ol package1 pgh_po) (:not (at_ol package1 bos_po)))
	(:set (in_oa package1 airplane1) false)
        (:set (in_ot package1 bos_truck) false)
        (:set (in_ot package1 pgh_truck) false)
        (:set (in_ot package1 phx_truck) false)
	(:set (at_oa package1 pgh_airport) false)	
	(:set (at_oa package1 bos_airport) false)
	(:set (at_oa package1 phx_airport) false)

	(:set (at_aa airplane1 pgh_airport) true)
	(:set (at_aa airplane1 phx_airport) false)
	(:set (at_aa airplane1 bos_airport) false)
	(:set (at_tl bos_truck bos_po) true)
       (:set (at_ta bos_truck bos_airport) false)
	(:set (at_tl bos_truck pgh_po) false)
	(:set (at_ta bos_truck pgh_airport) false)
	(:set (at_tl bos_truck phx_po) false)
	(:set (at_ta bos_truck phx_airport) false)
	(:set (at_tl pgh_truck pgh_po) true)
        (:set (at_ta pgh_truck bos_airport) false)
        (:set (at_tl pgh_truck bos_po) false)
        (:set (at_ta pgh_truck pgh_airport) false)
        (:set (at_tl pgh_truck phx_po) false)
        (:set (at_ta pgh_truck phx_airport) false)
	(:set (at_tl phx_truck phx_po) true)
       (:set (at_ta phx_truck bos_airport) false)
        (:set (at_tl phx_truck bos_po) false)
        (:set (at_ta phx_truck pgh_airport) false)
        (:set (at_tl phx_truck pgh_po) false)
        (:set (at_ta phx_truck phx_airport) false)
	(:set (in_city_l bos_po bos) true)
	(:set (in_city_l bos_po pgh) false)
	(:set (in_city_l bos_po phx) false)
	(:set (in_city_a bos_airport bos) true)
	(:set (in_city_a bos_airport pgh) false)
	(:set (in_city_a bos_airport phx) false)
	(:set (in_city_l pgh_po pgh) true)
	(:set (in_city_l phx_po bos) false)
	(:set (in_city_l phx_po pgh) false)
	(:set (in_city_a pgh_airport pgh) true)
	(:set (in_city_a phx_airport bos) false)
	(:set (in_city_a phx_airport pgh) false)
	(:set (in_city_l phx_po pgh) true)
	(:set (in_city_l pgh_po bos) false)
	(:set (in_city_l pgh_po phx) false)
	(:set (in_city_a phx_airport phx) true)
	(:set (in_city_a pgh_airport bos) false)
	(:set (in_city_a pgh_airport phx) false)
	(:set (in_city_t pgh_truck pgh) true)
	(:set (in_city_t pgh_truck bos) false)
	(:set (in_city_t pgh_truck phx) false)
	(:set (in_city_t bos_truck bos) true)
	(:set (in_city_t bos_truck pgh) false)
	(:set (in_city_t bos_truck phx) false)
	(:set (in_city_t phx_truck phx) true)
	(:set (in_city_t phx_truck pgh) false)
	(:set (in_city_t phx_truck bos) false)
)

  (:goal (at_oa package1 phx_airport)


	  )
)
(define (problem p4)   
(:domain log)
  (:objects     package1 - OBJ
	        package2 - OBJ
       		pgh_truck - TRUCK
                bos_truck - TRUCK
                 phx_truck - TRUCK
              airplane1 - AIRPLANE
                bos_po - LOCATION
                pgh_po - LOCATION
                  phx_po - LOCATION
              bos_airport - AIRPORT
                pgh_airport - AIRPORT
                 phx_airport - AIRPORT
               pgh - CITY
                bos - CITY
                 phx - CITY
       )
 (:init (:set (at_ol package1 pgh_po) :in {true false})
    	(:set (at_ol package1 bos_po) :in {true false})
	(:set (at_ol package2 pgh_po) :in {true false})
    	(:set (at_ol package2 bos_po) :in {true false})
	(:iff (at_ol package1 pgh_po) (:not (at_ol package1 bos_po)))
    	(:iff (at_ol package2 pgh_po) (:not (at_ol package2 bos_po)))
	(:set (in_oa package1 airplane1) false)
        (:set (in_ot package1 bos_truck) false)
        (:set (in_ot package1 pgh_truck) false)
        (:set (in_ot package1 phx_truck) false)
	(:set (at_oa package1 pgh_airport) false)	
	(:set (at_oa package1 bos_airport) false)
	(:set (at_oa package1 phx_airport) false)
	(:set (at_ol package1 bos_po) false)
	(:set (in_oa package2 airplane1) false)
        (:set (in_ot package2 bos_truck) false)
        (:set (in_ot package2 pgh_truck) false)
        (:set (in_ot package2 phx_truck) false)
	(:set (at_oa package2 pgh_airport) false)	
	(:set (at_oa package2 bos_airport) false)
	(:set (at_oa package2 phx_airport) false)
	(:set (at_ol package2 bos_po) false)

	(:set (at_aa airplane1 pgh_airport) true)
	(:set (at_aa airplane1 phx_airport) false)
	(:set (at_aa airplane1 bos_airport) false)

	(:set (at_tl bos_truck bos_po) true)
        (:set (at_ta bos_truck bos_airport) false)
	(:set (at_tl bos_truck pgh_po) false)
	(:set (at_ta bos_truck pgh_airport) false)
	(:set (at_tl bos_truck phx_po) false)
	(:set (at_ta bos_truck phx_airport) false)

	(:set (at_tl pgh_truck pgh_po) true)
        (:set (at_ta pgh_truck bos_airport) false)
        (:set (at_tl pgh_truck bos_po) false)
        (:set (at_ta pgh_truck pgh_airport) false)
        (:set (at_tl pgh_truck phx_po) false)
        (:set (at_ta pgh_truck phx_airport) false)

	(:set (at_tl phx_truck phx_po) true)
        (:set (at_ta phx_truck bos_airport) false)
        (:set (at_tl phx_truck bos_po) false)
        (:set (at_ta phx_truck pgh_airport) false)
        (:set (at_tl phx_truck pgh_po) false)
        (:set (at_ta phx_truck phx_airport) false)

	(:set (in_city_l bos_po bos) true)
	(:set (in_city_l bos_po pgh) false)
	(:set (in_city_l bos_po phx) false)

	(:set (in_city_a bos_airport bos) true)
	(:set (in_city_a bos_airport pgh) false)
	(:set (in_city_a bos_airport phx) false)

	(:set (in_city_l pgh_po pgh) true)
	(:set (in_city_l pgh_po bos) false)
	(:set (in_city_l pgh_po phx) false)

	(:set (in_city_a pgh_airport pgh) true)
	(:set (in_city_a pgh_airport bos) false)
	(:set (in_city_a pgh_airport phx) false)


	(:set (in_city_l phx_po pgh) true)
	(:set (in_city_l phx_po bos) false)
	(:set (in_city_l phx_po pgh) false)

	(:set (in_city_a phx_airport phx) true)
	(:set (in_city_a phx_airport bos) false)
	(:set (in_city_a phx_airport pgh) false)


	(:set (in_city_t pgh_truck pgh) true)
	(:set (in_city_t pgh_truck bos) false)
	(:set (in_city_t pgh_truck phx) false)

	(:set (in_city_t bos_truck bos) true)
	(:set (in_city_t bos_truck pgh) false)
	(:set (in_city_t bos_truck phx) false)

	(:set (in_city_t phx_truck phx) true)
	(:set (in_city_t phx_truck pgh) false)
	(:set (in_city_t phx_truck bos) false))

  (:goal (:and 
		(at_oa package1 phx_airport)
		(at_oa package2 phx_airport)

	  ))
)
(define (problem p5)   
(:domain log)
  (:objects     package1 - OBJ
	        package2 - OBJ
 	        package3 - OBJ
      		pgh_truck - TRUCK
                bos_truck - TRUCK
                 phx_truck - TRUCK
              airplane1 - AIRPLANE
                bos_po - LOCATION
                pgh_po - LOCATION
                  phx_po - LOCATION
              bos_airport - AIRPORT
                pgh_airport - AIRPORT
                 phx_airport - AIRPORT
               pgh - CITY
                bos - CITY
                 phx - CITY
       )
 (:init 
	(:set (at_ol package1 pgh_po) :in {true false})
    	(:set (at_ol package1 phx_po) :in {true false})

	(:set (at_ol package2 pgh_po) :in {true false})
    	(:set (at_ol package2 bos_po) :in {true false})

	(:set (at_ol package3 bos_po) :in {true false})
    	(:set (at_ol package3 phx_po) :in {true false})

	(:iff (at_ol package1 pgh_po) (:not (at_ol package1 phx_po)))
    	(:iff (at_ol package2 pgh_po) (:not (at_ol package2 bos_po)))
    	(:iff (at_ol package3 bos_po) (:not (at_ol package3 phx_po)))

	(:set (in_oa package1 airplane1) false)
        (:set (in_ot package1 bos_truck) false)
        (:set (in_ot package1 pgh_truck) false)
        (:set (in_ot package1 phx_truck) false)
	(:set (at_oa package1 pgh_airport) false)	
	(:set (at_oa package1 bos_airport) false)
	(:set (at_oa package1 phx_airport) false)
	(:set (at_ol package1 bos_po) false)

	(:set (in_oa package2 airplane1) false)
        (:set (in_ot package2 bos_truck) false)
        (:set (in_ot package2 pgh_truck) false)
        (:set (in_ot package2 phx_truck) false)
	(:set (at_oa package2 pgh_airport) false)	
	(:set (at_oa package2 bos_airport) false)
	(:set (at_oa package2 phx_airport) false)
	(:set (at_ol package2 phx_po) false)

	(:set (in_oa package3 airplane1) false)
        (:set (in_ot package3 bos_truck) false)
        (:set (in_ot package3 pgh_truck) false)
        (:set (in_ot package3 phx_truck) false)
	(:set (at_oa package3 pgh_airport) false)	
	(:set (at_oa package3 bos_airport) false)
	(:set (at_oa package3 phx_airport) false)
	(:set (at_ol package3 pgh_po) false)


	(:set (at_aa airplane1 pgh_airport) true)
	(:set (at_aa airplane1 phx_airport) false)
	(:set (at_aa airplane1 bos_airport) false)

	(:set (at_tl bos_truck bos_po) true)
        (:set (at_ta bos_truck bos_airport) false)
	(:set (at_tl bos_truck pgh_po) false)
	(:set (at_ta bos_truck pgh_airport) false)
	(:set (at_tl bos_truck phx_po) false)
	(:set (at_ta bos_truck phx_airport) false)

	(:set (at_tl pgh_truck pgh_po) true)
        (:set (at_ta pgh_truck bos_airport) false)
        (:set (at_tl pgh_truck bos_po) false)
        (:set (at_ta pgh_truck pgh_airport) false)
        (:set (at_tl pgh_truck phx_po) false)
        (:set (at_ta pgh_truck phx_airport) false)

	(:set (at_tl phx_truck phx_po) true)
        (:set (at_ta phx_truck bos_airport) false)
        (:set (at_tl phx_truck bos_po) false)
        (:set (at_ta phx_truck pgh_airport) false)
        (:set (at_tl phx_truck pgh_po) false)
        (:set (at_ta phx_truck phx_airport) false)

	(:set (in_city_l bos_po bos) true)
	(:set (in_city_l bos_po pgh) false)
	(:set (in_city_l bos_po phx) false)

	(:set (in_city_a bos_airport bos) true)
	(:set (in_city_a bos_airport pgh) false)
	(:set (in_city_a bos_airport phx) false)

	(:set (in_city_l pgh_po pgh) true)
	(:set (in_city_l pgh_po bos) false)
	(:set (in_city_l pgh_po phx) false)

	(:set (in_city_a pgh_airport pgh) true)
	(:set (in_city_a pgh_airport bos) false)
	(:set (in_city_a pgh_airport phx) false)


	(:set (in_city_l phx_po phx) true)
	(:set (in_city_l phx_po bos) false)
	(:set (in_city_l phx_po pgh) false)

	(:set (in_city_a phx_airport phx) true)
	(:set (in_city_a phx_airport bos) false)
	(:set (in_city_a phx_airport pgh) false)


	(:set (in_city_t pgh_truck pgh) true)
	(:set (in_city_t pgh_truck bos) false)
	(:set (in_city_t pgh_truck phx) false)

	(:set (in_city_t bos_truck bos) true)
	(:set (in_city_t bos_truck pgh) false)
	(:set (in_city_t bos_truck phx) false)

	(:set (in_city_t phx_truck phx) true)
	(:set (in_city_t phx_truck pgh) false)
	(:set (in_city_t phx_truck bos) false))

  (:goal (:and 
	(at_oa package1 bos_airport)
	(at_oa package2 phx_airport)
	(at_oa package3 pgh_airport)



	  ))
)
